/////////////////////////////////////////////////////////////////////////////
//
//                       Demo Application for
//       DLL API for RDS Signal Generator "HG 81300-B/PC" v1.0
//      -------------------------------------------------------
//
//   remote control of RDS-coder "HG 81300-B/PC" via serial COM port
//   for Microsoft Windows 32 bit, developed with Microsoft Visual C++ 6.0
//
//   (C) 2001 by Gtting KG, radio sets   Author: O. Herbst, Feb. 2001
//
//   address: Gtting KG, Celler Strae 5, 31275 Lehrte/Rddensen, Germany
//   http:    www.goetting.de
//   email:   RDS-Support@Goetting.de
//
/////////////////////////////////////////////////////////////////////////////


// RDS HG813B DLL Demo Dlg.cpp : implementation file
//
// NOTE:
//   All identifiers starting with "HG_" refer
//   to the DLL for RDS-coder "HG 81300-B/PC".

#include "stdafx.h"
#include <stdlib.h>
#include "RDS HG813B DLL Demo.h"
#include "RDS HG813B DLL Demo Dlg.h"
#include "RDS HG81300B.h"  // DLL API

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialog CAboutDlg for application command "info..."

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV-support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

// About dialog definition //////////////////////////////////////////////////

CAboutDlg::CAboutDlg() : CDialog (CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange (CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// dialog CCOMSelectDlg for selecting the serial port COMx

class CCOMSelectDlg : public CDialog
{
public:
	CCOMSelectDlg(CWnd* pParent = NULL);  // Default-Construktor

	//{{AFX_DATA(CCOMSelectDlg)
	enum { IDD = IDD_COM_SELECT };
	int		m_COMx;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CCOMSelectDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV-support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CCOMSelectDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

// COM select dialog definition /////////////////////////////////////////////

CCOMSelectDlg::CCOMSelectDlg (CWnd* pParent /*=NULL*/)
             : CDialog (CCOMSelectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCOMSelectDlg)
	m_COMx = -1;
	//}}AFX_DATA_INIT
}

void CCOMSelectDlg::DoDataExchange (CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCOMSelectDlg)
	DDX_Radio(pDX, IDC_RADIO_COM1, m_COMx);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCOMSelectDlg, CDialog)
	//{{AFX_MSG_MAP(CCOMSelectDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// dialog CProgSlotListDlg for selecting a program out of the slot list

class CProgSlotListDlg : public CDialog
{
public:
	CProgSlotListDlg (CWnd* pParent = NULL);
    void SetData (sHG_ProgSlot* List, int slot = 0);
    
protected:
    sHG_ProgSlot* m_ProgList;
    int           m_CurrSlot;

    //{{AFX_DATA(CProgSlotListDlg)
    enum { IDD = IDD_SLOTLIST };
    CListCtrl	m_ListCtrl;
    //}}AFX_DATA

    //{{AFX_VIRTUAL(CProgSlotListDlg)
//  public:
//  virtual BOOL OnChildNotify(UINT message, WPARAM wParam,
//                             LPARAM lParam, LRESULT* pLResult);
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    //}}AFX_VIRTUAL

protected:
    void FillListCtrl();

    //{{AFX_MSG(CProgSlotListDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnDblClkProgSlotList(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnProgSlotSelBtn();
    afx_msg void OnProgSlotDelBtn();
    afx_msg void OnOffBtn();
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

// program slot list dialog definition //////////////////////////////////////

CProgSlotListDlg::CProgSlotListDlg (CWnd* pParent /*=NULL*/)
                : CDialog (CProgSlotListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProgSlotListDlg)
	//}}AFX_DATA_INIT
    m_ProgList = NULL;
    m_CurrSlot = 1;
}

void CProgSlotListDlg::SetData (sHG_ProgSlot* List, int Slot)
{
    m_ProgList = List;
    m_CurrSlot = Slot;
}

void CProgSlotListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgSlotListDlg)
	DDX_Control(pDX, IDC_PROGSLOT_LIST, m_ListCtrl);
	//}}AFX_DATA_MAP
}

BOOL CProgSlotListDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    // Insert columns into the Program Slot List
    char str[100+1];
    LoadString(0, IDS_LIST_NAME, str, 100);
    m_ListCtrl.InsertColumn(0, str, LVCFMT_LEFT,  90, 1);
    LoadString(0, IDS_LIST_NO, str, 100);
    m_ListCtrl.InsertColumn(1, str, LVCFMT_RIGHT, 30, 0);
    LoadString(0, IDS_LIST_TIMES, str, 100);
    m_ListCtrl.InsertColumn(2, str, LVCFMT_RIGHT, 43, 2);
    LoadString(0, IDS_LIST_NEXT, str, 100);
    m_ListCtrl.InsertColumn(3, str, LVCFMT_RIGHT, 30, 3);
    LoadString(0, IDS_LIST_LEN, str, 100);
    m_ListCtrl.InsertColumn(4, str, LVCFMT_RIGHT, 47, 4);
    LoadString(0, IDS_LIST_DURATION, str, 100);
    m_ListCtrl.InsertColumn(5, str, LVCFMT_RIGHT, 69, 5);

    FillListCtrl();
	
    return TRUE;
}

void CProgSlotListDlg::FillListCtrl()
{
    if (m_ProgList==NULL)
        return;  // Abbort

    m_ListCtrl.DeleteAllItems();

    // insert all occupied program slots
    char str[100+1];
    LV_ITEM item;
    item.pszText = str;
    int i=0;
    while (m_ProgList[i].slot)  // or use HG_GetNumberOfProgs()
    {
        item.iItem = i;
        item.mask = LVIF_TEXT | LVIF_PARAM;
        item.lParam = m_ProgList[i].slot;
        item.iSubItem = 0;  // name
        strncpy(str, m_ProgList[i].strname, 8+1);
        int itemNr = m_ListCtrl.InsertItem(&item);
        if (m_ProgList[i].slot==m_CurrSlot)  // mark current slot
            m_ListCtrl.SetItemState (i, LVIS_FOCUSED, LVIS_FOCUSED);

        item.iItem = itemNr;
        item.mask = LVIF_TEXT;
        item.iSubItem = 1;  // slot number
        sprintf(str, "%d", m_ProgList[i].slot);
        m_ListCtrl.SetItem(&item);

        item.iSubItem = 2;  // times
        if (m_ProgList[i].times)
            sprintf(str, "%d", m_ProgList[i].times);
        else
            strcpy(str, "---");
        m_ListCtrl.SetItem(&item);

        item.iSubItem = 3;  // next slot number
        if (m_ProgList[i].next_slot &&
            m_ProgList[i].times       )
            sprintf(str, "%d", m_ProgList[i].next_slot);
        else
            strcpy(str, "---");
        m_ListCtrl.SetItem(&item);

        item.iSubItem = 4;  // number of groups
        sprintf(str, "%d", m_ProgList[i].groups);
        m_ListCtrl.SetItem(&item);

        item.iSubItem = 5;  // duration [s]
        if (m_ProgList[i].times>0)  // duration in seconds (RDS: 1187.5 bps)
            sprintf(str, "%.3lf",   m_ProgList[i].times 
                                   *m_ProgList[i].bytes *8 /1187.5);
        else
            sprintf(str, "[%.3lf]", m_ProgList[i].bytes *8 /1187.5);
        m_ListCtrl.SetItem(&item);
        i++;
    }
}//::FillListCtrl()

// functions for message handling of CProgSlotListDlg ///////////////////////

BEGIN_MESSAGE_MAP(CProgSlotListDlg, CDialog)
    //{{AFX_MSG_MAP(CProgSlotListDlg)
    ON_NOTIFY(NM_DBLCLK, IDC_PROGSLOT_LIST, OnDblClkProgSlotList)
    ON_BN_CLICKED(IDC_PROGSLOT_SEL_BTN, OnProgSlotSelBtn)
    ON_BN_CLICKED(IDC_PROGSLOT_DEL_BTN, OnProgSlotDelBtn)
    ON_BN_CLICKED(IDC_OFF_BTN, OnOffBtn)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CProgSlotListDlg::OnDblClkProgSlotList(NMHDR* pNMHDR, LRESULT* pResult)
{                                          // switch to program slot
    int i = m_ListCtrl.GetSelectionMark();
    if (i==-1)
        return;
    int s = m_ListCtrl.GetItemData (i);
    ((CRDS_HG813B_DLL_Demo_Dlg*)GetParent())->SlotSel (s);
    *pResult = 0;
}

void CProgSlotListDlg::OnProgSlotSelBtn()  // switch to program slot
{
    int i = m_ListCtrl.GetSelectionMark();
    if (i==-1)
        return;
    int s = m_ListCtrl.GetItemData (i);
    ((CRDS_HG813B_DLL_Demo_Dlg*)GetParent())->SlotSel (s);
}

void CProgSlotListDlg::OnProgSlotDelBtn()  // delete program
{
    int i = m_ListCtrl.GetSelectionMark();
    if (i==-1)
        return;
    int s = m_ListCtrl.GetItemData (i);
    ((CRDS_HG813B_DLL_Demo_Dlg*)GetParent())->SlotDel (s);
    FillListCtrl();
}

void CProgSlotListDlg::OnOffBtn()  // switch off
{
    ((CRDS_HG813B_DLL_Demo_Dlg*)GetParent())->SlotSel (HG_NO_SLOT);
}


/////////////////////////////////////////////////////////////////////////////
// main dialog CRDS_HG813B_DLL_Demo_Dlg definition

CRDS_HG813B_DLL_Demo_Dlg::CRDS_HG813B_DLL_Demo_Dlg (CWnd* pParent /*=NULL*/)
	                    : CDialog (CRDS_HG813B_DLL_Demo_Dlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CRDS_HG813B_DLL_Demo_Dlg)
    m_SlotNo = 0;
    m_Times  = 0;
    m_NextNo = 0;
    m_FreqA = 0.0;
    m_FreqB = 0.0;
    m_FreqASliderValue = 0;
    m_FreqBSliderValue = 0;
    m_Memory = _T("");
    //}}AFX_DATA_INIT

    m_hIcon = AfxGetApp()->LoadIcon (IDR_MAINFRAME);
    m_strTitle      = _T("");
    m_strFilename   = _T("");
    m_acSlotName[0] = '\0';
}

void CRDS_HG813B_DLL_Demo_Dlg::DoDataExchange (CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CRDS_HG813B_DLL_Demo_Dlg)
	DDX_Text(pDX, IDC_NUMBER_EDIT, m_SlotNo);
	DDV_MinMaxInt(pDX, m_SlotNo, HG_SLOT_NUMBER_MIN, HG_SLOT_NUMBER_MAX);
	DDX_Text(pDX, IDC_TIMES_EDIT, m_Times);
	DDV_MinMaxInt(pDX, m_Times, HG_SLOT_TIMES_INFINITE, HG_SLOT_TIMES_MAX);
	DDX_Text(pDX, IDC_NEXTNO_EDIT, m_NextNo);
	DDV_MinMaxInt(pDX, m_NextNo, HG_SLOT_NUMBER_MIN, HG_SLOT_NUMBER_MAX);
	DDX_Text(pDX, IDC_FREQA_EDIT, m_FreqA);
	DDV_MinMaxDouble(pDX, m_FreqA, HG_FREQ_MIN, HG_FREQ_MAX);
	DDX_Text(pDX, IDC_FREQB_EDIT, m_FreqB);
	DDV_MinMaxDouble(pDX, m_FreqB, HG_FREQ_MIN, HG_FREQ_MAX);
	DDX_Control(pDX, IDC_FREQA_SLIDER, m_FreqASlider);
	DDX_Slider(pDX, IDC_FREQA_SLIDER, m_FreqASliderValue);
	DDX_Control(pDX, IDC_FREQB_SLIDER, m_FreqBSlider);
	DDX_Slider(pDX, IDC_FREQB_SLIDER, m_FreqBSliderValue);
	DDX_Control(pDX, IDC_SK_CHK, m_SK);
	DDX_Control(pDX, IDC_BK_CHK, m_BK);
	DDX_Control(pDX, IDC_DK_CHK, m_DK);
	DDX_Control(pDX, IDC_PILOT_CHK, m_Pilot);
	DDX_Control(pDX, IDC_STEREO_CHK, m_Stereo);
	DDX_Control(pDX, IDC_ST1L_CHK, m_ST1L);
	DDX_Control(pDX, IDC_ST1R_CHK, m_ST1R);
	DDX_Control(pDX, IDC_ST2L_CHK, m_ST2L);
	DDX_Control(pDX, IDC_ST2R_CHK, m_ST2R);
	DDX_Control(pDX, IDC_TIMER_CHK, m_TimerCheck);
	DDX_Text(pDX, IDC_MEMORY, m_Memory);
	DDX_Control(pDX, IDC_PROGRESS1, m_Progress1);
	DDX_Control(pDX, IDC_PROGRESS2, m_Progress2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRDS_HG813B_DLL_Demo_Dlg, CDialog)
	//{{AFX_MSG_MAP(CRDS_HG813B_DLL_Demo_Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_FREQA_BTN, OnFreqA_Btn)
	ON_BN_CLICKED(IDC_FREQB_BTN, OnFreqB_Btn)
	ON_BN_CLICKED(IDC_FREQA_RAD, OnFreqA_Rad)
	ON_BN_CLICKED(IDC_FREQB_RAD, OnFreqB_Rad)
	ON_BN_CLICKED(IDC_SK_BTN, OnSK_Btn)
	ON_BN_CLICKED(IDC_BK_BTN, OnBK_Btn)
	ON_BN_CLICKED(IDC_DK_BTN, OnDK_Btn)
	ON_BN_CLICKED(IDC_SK_CHK, OnSK_Chk)
	ON_BN_CLICKED(IDC_BK_CHK, OnBK_Chk)
	ON_BN_CLICKED(IDC_DK_CHK, OnDK_Chk)
	ON_BN_CLICKED(IDC_PILOT_CHK, OnPilotChk)
	ON_BN_CLICKED(IDC_STEREO_CHK, OnStereoChk)
	ON_BN_CLICKED(IDC_ST1L_CHK, OnST1L_Chk)
	ON_BN_CLICKED(IDC_ST1R_CHK, OnST1R_Chk)
	ON_BN_CLICKED(IDC_ST2L_CHK, OnST2L_Chk)
	ON_BN_CLICKED(IDC_ST2R_CHK, OnST2R_Chk)
	ON_BN_CLICKED(IDC_PROGLIST_BTN, OnProgListBtn)
	ON_BN_CLICKED(IDC_TEST1_BTN, OnTest1Btn)
	ON_BN_CLICKED(IDC_TEST2_BTN, OnTest2Btn)
	ON_BN_CLICKED(IDC_LOAD_BTN, OnLoadBtn)
	ON_BN_CLICKED(IDC_FIRMA_BMP, OnFirmaBmp)
	ON_BN_CLICKED(IDC_RESET_BTN, OnResetBtn)
	ON_BN_CLICKED(IDC_COM_BTN, OnCOMnBtn)
	//}}AFX_MSG_MAP

	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
    ON_MESSAGE (WM_USER, OnWM_User)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRDS_HG813B_DLL_Demo_Dlg message handler

BOOL CRDS_HG813B_DLL_Demo_Dlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Add command "info..." to the system menu
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);
    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString (IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu (MF_SEPARATOR);
            pSysMenu->AppendMenu (MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // set icon for this dialog
    SetIcon(m_hIcon, TRUE);   // big icon
    SetIcon(m_hIcon, FALSE);  // small icon
	
    EnableToolTips(TRUE);
    m_waitcur = AfxGetApp()->LoadCursor(IDC_RDS_CUR);
    m_normcur = AfxGetApp()->LoadCursor(IDC_APPSTARTING);
    m_strTitle.LoadString (IDS_RDSCODER);
    CString str;
    str.LoadString (IDS_LANGUAGE);
    if (str == _T("deutsch"))
        HG_ErrorMsg(0, 2);  // set language of error messages

    // frequency sliders
    #define FREQSTEP 10  // *0.1 MHz

    m_FreqASliderValue = int(HG_FREQ_MIN*10.);
    m_FreqBSliderValue = int(HG_FREQ_MAX*10.);
    m_FreqASlider.SetRange(int(HG_FREQ_MIN*FREQSTEP), int(HG_FREQ_MAX*FREQSTEP));
    m_FreqBSlider.SetRange(int(HG_FREQ_MIN*FREQSTEP), int(HG_FREQ_MAX*FREQSTEP));
    for (int f=int(HG_FREQ_MIN); f<=int(HG_FREQ_MAX); f++)  // full MHz
        m_FreqASlider.SetTic(f*FREQSTEP);
    m_FreqASlider.SetPageSize(FREQSTEP);
    m_FreqBSlider.SetPageSize(FREQSTEP);
    m_FreqASlider.SetPos(m_FreqASlider.GetRangeMin());  // default
    m_FreqBSlider.SetPos(m_FreqBSlider.GetRangeMax());  // default

    // spin control for program slot number
    ((CSpinButtonCtrl*)GetDlgItem(IDC_NUMBER_SPIN))->SetRange (HG_NO_SLOT,
                                                               HG_SLOT_NUMBER_MAX);
    ((CSpinButtonCtrl*)GetDlgItem(IDC_NEXTNO_SPIN))->SetRange (HG_NO_SLOT,
                                                               HG_SLOT_NUMBER_MAX);
    ((CSpinButtonCtrl*)GetDlgItem(IDC_TIMES_SPIN) )->SetRange (HG_SLOT_TIMES_INFINITE,
                                                               HG_SLOT_TIMES_MAX);
    m_Progress1.SetRange (0,100);  // init progress display
    m_Progress2.SetRange (0,100);

    // first: selection of desired COM port in separate dialog
    PostMessage (WM_USER, 12345);

	return TRUE;
}//::OnInitDialog()

void CRDS_HG813B_DLL_Demo_Dlg::Refresh (bool showcursor)
{
    if (showcursor)
        SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // get state of all switches (functions, generators)
    int result = HG_GetState (&m_sCoderState);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    if (showcursor)
        SetCursor(m_normcur);
    if (result!=HG_ERR_NO)
    {
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
        if (result!=HG_ERR_READING) 
            return;  // m_sCoderState not valid
    }

    // update control elements
    CString strFreq;
    m_FreqA = m_sCoderState.fFreqA;
    if (m_FreqA>0) 
        strFreq.Format("%.1lf", m_FreqA);
    else 
        strFreq = _T("");
    SetDlgItemText(IDC_FREQA_EDIT, strFreq);
    m_FreqASlider.SetPos (int(10.*(m_FreqA > 0 ? m_FreqA : HG_FREQ_MIN)));
    m_FreqB = m_sCoderState.fFreqB;
    if (m_FreqB>0)
        strFreq.Format("%.1lf", m_FreqB);
    else 
        strFreq = _T("");
    SetDlgItemText(IDC_FREQB_EDIT, strFreq);
    m_FreqBSlider.SetPos (int(10.*(m_FreqB > 0 ? m_FreqB : HG_FREQ_MAX)));

    m_SlotNo = m_sCoderState.Slot;
    if (m_sCoderState.Slot>0)
        SetDlgItemInt(IDC_NUMBER_EDIT, m_SlotNo, false);
    else 
        SetDlgItemText(IDC_NUMBER_EDIT, _T(""));

    SetDlgItemText(IDC_TIMES_EDIT,  _T(""));
    SetDlgItemText(IDC_NEXTNO_EDIT, _T(""));

    SendDlgItemMessage(IDC_FREQA_RAD, BM_SETCHECK,
                       m_sCoderState.FreqA > 0 ? BST_CHECKED : BST_UNCHECKED);
    SendDlgItemMessage(IDC_FREQB_RAD, BM_SETCHECK,
                       m_sCoderState.FreqA > 0 ? BST_UNCHECKED : BST_CHECKED);
    m_SK.SetCheck(m_sCoderState.SK > 0 ? BST_CHECKED :
                  m_sCoderState.SK ==0 ? BST_UNCHECKED :
                                         BST_INDETERMINATE);
    m_BK.SetCheck(m_sCoderState.BK > 0 ? BST_CHECKED :
                  m_sCoderState.BK ==0 ? BST_UNCHECKED :
                                         BST_INDETERMINATE);
    m_DK.SetCheck(m_sCoderState.DK > 0 ? BST_CHECKED :
                  m_sCoderState.DK ==0 ? BST_UNCHECKED :
                                         BST_INDETERMINATE);
    m_Pilot.SetCheck(m_sCoderState.Pilot > 0 ? BST_CHECKED :
                     m_sCoderState.Pilot ==0 ? BST_UNCHECKED :
                                               BST_INDETERMINATE);
    m_Stereo.SetCheck(m_sCoderState.Stereo > 0 ? BST_CHECKED :
                      m_sCoderState.Stereo ==0 ? BST_UNCHECKED :
                                                 BST_INDETERMINATE);
    m_ST1L.SetCheck(m_sCoderState.ST1L > 0 ? BST_CHECKED :
                    m_sCoderState.ST1L ==0 ? BST_UNCHECKED :
                                             BST_INDETERMINATE);
    m_ST1R.SetCheck(m_sCoderState.ST1R > 0 ? BST_CHECKED :
                    m_sCoderState.ST1R ==0 ? BST_UNCHECKED :
                                             BST_INDETERMINATE);
    m_ST2L.SetCheck(m_sCoderState.ST2L > 0 ? BST_CHECKED :
                    m_sCoderState.ST2L ==0 ? BST_UNCHECKED :
                                             BST_INDETERMINATE);
    m_ST2R.SetCheck(m_sCoderState.ST2R > 0 ? BST_CHECKED :
                    m_sCoderState.ST2R ==0 ? BST_UNCHECKED :
                                             BST_INDETERMINATE);
    if (showcursor)
        SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    if (result==HG_ERR_NO)
        result = HG_GetFreeMemory();
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    if (showcursor)
        SetCursor(m_normcur);
    if (result > HG_ERR_NO)
        m_Memory.Format (IDS_MEMORY, result);
    else
        m_Memory.LoadString (IDS_MEMORYX);
    SetDlgItemText (IDC_MEMORY, m_Memory);

    if (!m_TimerCheck.GetCheck())
    {
        m_Progress1.SetPos(0);
        m_Progress2.SetPos(0);
    }
}//::Refresh()

void CRDS_HG813B_DLL_Demo_Dlg::SlotSel (int slot)
{
    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    int result = HG_SelectProg (slot);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::SlotDel (int slot)
{
    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    int result = HG_DeleteProg (slot);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnSysCommand (UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
        CDialog::OnSysCommand (nID, lParam);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnDestroy()
{
    KillTimer(1);
  //WinHelp(0L, HELP_QUIT);
    CDialog::OnDestroy();
}

void CRDS_HG813B_DLL_Demo_Dlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this);  // device context for drawing

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width()  -cxIcon +1) /2;
        int y = (rect.Height() -cyIcon +1) /2;
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
        CDialog::OnPaint();
}

HCURSOR CRDS_HG813B_DLL_Demo_Dlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

void CRDS_HG813B_DLL_Demo_Dlg::OnTimer (UINT nIDEvent) 
{
    static bool merk;

    CDialog::OnTimer(nIDEvent);

    if (m_TimerCheck.GetCheck())
    {
        ////////////////// HG 81300-B/PC ////////////////////////////////
        if (HG_GetState (&m_sCoderState) != HG_ERR_NO)
        ////////////////// HG 81300-B/PC ////////////////////////////////
            m_TimerCheck.SetCheck(0);
        Refresh (false);
        merk ^= true;
        m_Progress1.SetPos (merk ? 100 : 0);
        m_Progress2.SetPos (merk ? 0 : 100);
    }
    else 
    {
        m_Progress1.SetPos(0);
        m_Progress2.SetPos(0);
    }
}

///// events of the control elements ////////////////////////////////////////

void CRDS_HG813B_DLL_Demo_Dlg::OnTest1Btn()
{
    Test(1);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnTest2Btn()
{
    Test(2);
}

void CRDS_HG813B_DLL_Demo_Dlg::Test (int nr )  // nr==1 or 2
{
    #define REPEAT 1  // number of data copies in memory
    #define DATALEN1 ((4+12+1)*13)  // 17 RDS groups
    BYTE data1 [DATALEN1] = {
        // small RDS test program: PI=1234, PTY=Pop, TP=1
        //   4 groups of type 0A: TA=0, M/S=1, DI=1, AF=7 freq., PS="DLL Demo"
        //  12 groups of type 2A: line A: "The quick brown fox..."
        //   1 group  of type 4A: 1.1.2000, 12:34 +1h
       0x12, 0x34,0x1A,0x81,0x52,0x10,0x0E,0x70,0x52,0x9D,0x11,0x30,0x4A,
        0x12,0x34,0x1A,0x89,0x50,0x1A,0xC5,0x46,0x88,0x1D,0x94,0x81,0x97,
        0x12,0x34,0x1A,0x89,0x50,0x41,0x57,0x17,0x51,0x71,0xA5,0x8F,0x42,
        0x12,0x34,0x1A,0x89,0x50,0xAD,0xE6,0xB2,0x03,0x69,0x89,0xCB,0x79,
       0x12, 0x34,0x1A,0x81,0x52,0x4B,0x92,0x64,0x8C,0xED,0x30,0x81,0xBD,
        0x12,0x34,0x1A,0x89,0x50,0xF6,0x76,0xF7,0x76,0xD1,0xB8,0x83,0xAA,
        0x12,0x34,0x1A,0x89,0x51,0x2F,0x16,0x66,0xFA,0x35,0xE0,0x82,0x69,
        0x12,0x34,0x1A,0x89,0x51,0x74,0x86,0xA7,0x55,0xA9,0xB5,0xC1,0x46,
       0x12, 0x34,0x1A,0x81,0x52,0xA7,0x26,0x98,0xAE,0xE9,0x11,0x94,0x37,
        0x12,0x34,0x1A,0x89,0x51,0x98,0x37,0x32,0x02,0x21,0xBD,0xD8,0xD1,
        0x12,0x34,0x1A,0x89,0x51,0xC3,0xA6,0x57,0x26,0xC4,0x81,0xD0,0x09,
        0x12,0x34,0x1A,0x89,0x52,0x2A,0xF6,0x86,0x5D,0xB4,0x81,0xB0,0xB5,
       0x12, 0x34,0x1A,0x81,0x53,0xC9,0x6A,0xCC,0xCA,0x79,0xB5,0xBC,0x6C,
        0x12,0x34,0x1A,0x89,0x52,0x71,0x66,0x17,0xA7,0x09,0xE4,0x82,0xB5,
        0x12,0x34,0x1A,0x89,0x52,0x9D,0xD6,0x46,0xFC,0xD5,0x9C,0x85,0x96,
        0x12,0x34,0x1A,0x89,0x52,0xC6,0x40,0xD0,0x06,0x74,0x00,0x01,0xB4,
       0x12, 0x34,0x1A,0x91,0x50,0x55,0xD9,0x2B,0x0A,0xEB,0x22,0x0B,0x61,
    };
    #define DATALEN2 ((4+16)*13)  // 20 RDS groups
    BYTE data2 [DATALEN2] = {
        // small RDS test program: PI=1234, PTY=News, TP=1
        //   4 groups of Typ=0A: TA=1, M/S=0, DI=1, AF=7 freq., PS="DLL-Demo"
        //  16 groups of Typ=2A: line B: "generated by..."
       0x12, 0x34,0x1A,0x81,0x0C,0x39,0x0E,0x70,0x52,0x9D,0x11,0x30,0x4A,
        0x12,0x34,0x1A,0x89,0x0C,0x03,0xF6,0x76,0x58,0x81,0xB9,0x95,0x79,
        0x12,0x34,0x1A,0x89,0x0C,0x58,0x67,0x26,0x17,0x69,0xD1,0x94,0x93,
        0x12,0x34,0x1A,0x89,0x0C,0xB4,0xD6,0x42,0x06,0x5D,0x89,0xE6,0xB1,
        0x12,0x34,0x1A,0x89,0x0C,0xEF,0x42,0x05,0x28,0xF5,0x11,0x4D,0x60,
       0x12, 0x34,0x1A,0x81,0x0C,0x62,0x92,0x64,0x8C,0xED,0x30,0xB4,0x5A,
        0x12,0x34,0x1A,0x89,0x0D,0x36,0x22,0xD4,0x33,0x39,0xBD,0x90,0x1C,
        0x12,0x34,0x1A,0x89,0x0D,0x6D,0xB6,0x57,0x26,0xC4,0x81,0x21,0x2F,
        0x12,0x34,0x1A,0x89,0x0D,0x81,0x04,0x73,0x8F,0x80,0xC4,0xCE,0x7F,
        0x12,0x34,0x1A,0x89,0x0D,0xDA,0x94,0x22,0xD4,0x5D,0x41,0x0E,0xA4,
       0x12, 0x34,0x1A,0x81,0x0C,0x8E,0x26,0x98,0xAE,0xE9,0x11,0x94,0x37,
        0x12,0x34,0x1A,0x89,0x0E,0x33,0xC2,0xC2,0x00,0xA5,0x1E,0x5F,0x00,
        0x12,0x34,0x1A,0x89,0x0E,0x68,0x57,0x47,0x49,0x25,0xA5,0xBA,0xA5,
        0x12,0x34,0x1A,0x89,0x0E,0x84,0xE6,0x72,0x03,0xCD,0x2D,0x1C,0xCF,
        0x12,0x34,0x1A,0x89,0x0E,0xDF,0x72,0xC2,0x00,0xA5,0xDD,0xDD,0x3A,
       0x12, 0x34,0x1A,0x81,0x0D,0xE0,0x6A,0xCC,0xCA,0x79,0xB5,0xBC,0x6C,
        0x12,0x34,0x1A,0x89,0x0F,0x06,0x17,0x72,0xE3,0x51,0x9D,0xBE,0x8D,
        0x12,0x34,0x1A,0x89,0x0F,0x5D,0x86,0x57,0x46,0x79,0xD1,0xA4,0xCD,
        0x12,0x34,0x1A,0x89,0x0F,0xB1,0x36,0xE6,0x7B,0x5C,0xB9,0x92,0x27,
        0x12,0x34,0x1A,0x89,0x0F,0xEA,0xA6,0x50,0x0E,0x30,0x00,0x01,0xB4,
    };
    int  len, result;
    char strName [HG_NAME_LEN_MAX+1];
    BYTE *data, *datarepeat;

    len  = nr==1 ? DATALEN1 : DATALEN2;
    data = nr==1 ? data1    : data2;
    datarepeat = (BYTE*)malloc(len*REPEAT);
    if (datarepeat==NULL)
        return;
    for (int i=0; i<REPEAT; i++)
        memcpy (datarepeat +i*len, data, len);
    strcpy (strName, nr==1 ? "Demo 1" : "Demo 2");

    m_SlotNo = GetDlgItemInt (IDC_NUMBER_EDIT, NULL, false);
    m_Times  = GetDlgItemInt (IDC_TIMES_EDIT,  NULL, false);
    m_NextNo = GetDlgItemInt (IDC_NEXTNO_EDIT, NULL, false);

    if (m_SlotNo==0) 
    {
        CString str;
        str.LoadString(IDS_NO_SLOT_NUMBER);
        MessageBox(str, m_strTitle, MB_ICONEXCLAMATION);
        return;
    }

    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // send data to RDS-coder
    result = HG_StoreProg (datarepeat, len*REPEAT /13,
                           m_SlotNo, m_Times, m_NextNo, strName);
    ////////////////// HG 81300-B/PC /////////////////////////////////////

    SetCursor(m_normcur);
    if (result != HG_ERR_NO)
    {
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
        return;
    }

    SlotSel (m_SlotNo);  // switch to the new program
}//::Test()

void CRDS_HG813B_DLL_Demo_Dlg::OnLoadBtn()  // load RDS data out of a file
{
    m_SlotNo = GetDlgItemInt (IDC_NUMBER_EDIT, NULL, false);
    if (m_SlotNo==0)  // invalid number
    {
        CString str;
        str.LoadString(IDS_NO_SLOT_NUMBER);
        MessageBox(str, m_strTitle, MB_ICONEXCLAMATION);
        return;
    }

    // select and open file
    CString strTitle, strExtens;
    strTitle .LoadString(IDS_FILETITLE);
    strExtens.LoadString(IDS_EXTENSIONS);
    CFileDialog FileSelector (TRUE, NULL, m_strFilename,
                              OFN_FILEMUSTEXIST |OFN_ENABLESIZING |OFN_HIDEREADONLY,
                              strExtens, this);
    FileSelector.m_ofn.lpstrTitle = strTitle;
    if (FileSelector.DoModal()!=IDOK)
        return;
    RedrawWindow();

    // generate name for prog slot out of the file name
    int n = 0; 
    int m = FileSelector.m_ofn.nFileOffset;
    while (n < HG_NAME_LEN_MAX  &&
           m+1 < FileSelector.m_ofn.nFileExtension)
        m_acSlotName[n++] = FileSelector.m_ofn.lpstrFile[m++];
    m_acSlotName[n] = '\0';
    m_strFilename = FileSelector.m_ofn.lpstrFile;

    LoadFile();
}

void CRDS_HG813B_DLL_Demo_Dlg::LoadFile()  // store RDS sequence file into program slot
{
    CFile file;
    CFileException fileException;
    int len, result;
    
    if (!file.Open(m_strFilename, CFile::modeRead, &fileException))
    {
        CString str;
        str.Format(IDS_FILE_READ_ERROR, m_strFilename, fileException.m_cause);
        MessageBox(str, m_strTitle, MB_ICONEXCLAMATION);
        return;
    }

    // read RDS data sequence
    len = file.GetLength();
    if (len % 13)  // multiples of 13!
    {
        CString str;
        str.Format(IDS_FILE_LEN_ERROR, m_strFilename, fileException.m_cause);
        MessageBox(str, m_strTitle, MB_ICONEXCLAMATION);
        return;
    }
    char *data = (char*)malloc(len);
    if (data==NULL)
    {
        file.Close();
        return;
    }
    result = file.Read (data, len);
    if (result!=len)
    {
        free(data);
        file.Close();

        CString str;
        str.Format(IDS_FILE_READ_ERROR, m_strFilename, fileException.m_cause);
        MessageBox(str, m_strTitle, MB_ICONEXCLAMATION);
        return;
    }
    file.Close();

    m_SlotNo = GetDlgItemInt (IDC_NUMBER_EDIT, NULL, false);
    m_Times  = GetDlgItemInt (IDC_TIMES_EDIT,  NULL, false);
    m_NextNo = GetDlgItemInt (IDC_NEXTNO_EDIT, NULL, false);

    // show info if programming will take longer than a few seconds
    int duration = len    // byte
                   *2     // char/byte
                   *10    // bit/char (8n1)
                   /9600  // bit/sec
                   +1;    // overhead
    if (duration >= 5)    // sec
    {
        CString str;
        str.Format(IDS_TIME_INFO, duration);
        result = MessageBox(str, m_strTitle, MB_ICONINFORMATION | MB_OKCANCEL);  // Info
    }
    else
        result =IDOK;

    if (result==IDOK)
    {
      SetCursor(m_waitcur);

      ////////////////// HG 81300-B/PC ////////////////////////////////////
      // send data to RDS-coder
      result = HG_StoreProg (data, len /13, m_SlotNo, m_Times, m_NextNo, m_acSlotName);
      ////////////////// HG 81300-B/PC ////////////////////////////////////

      SetCursor(m_normcur);

      if (result != HG_ERR_NO)
      {
          MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
          return;
      }

      SlotSel (m_SlotNo);  // switch to the new program
    }

    free(data);
}//::LoadFile()

void CRDS_HG813B_DLL_Demo_Dlg::OnFreqA_Btn() 
{
    CString strFreq;
    GetDlgItemText (IDC_FREQA_EDIT, strFreq);
    sscanf(strFreq, "%lf", &m_FreqA);

    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // set frequency A
    int result = HG_SetFreq (HG_FREQ_A, m_FreqA);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnFreqB_Btn() 
{
    CString strFreq;
    GetDlgItemText (IDC_FREQB_EDIT, strFreq);
    sscanf(strFreq, "%lf", &m_FreqB);

    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // set frequency B
    int result = HG_SetFreq (HG_FREQ_B, m_FreqB);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnFreqA_Rad() 
{
    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // switch to frequency A
    int result = HG_SetSwitch (HG_FREQ_A, m_sCoderState.FreqA==1 ? false : true);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnFreqB_Rad() 
{
    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // switch to frequency B
    int result = HG_SetSwitch (HG_FREQ_B, m_sCoderState.FreqA!=1 ? false : true);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnSK_Btn() 
{
    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // switch ARI SK
    int result = HG_SetSwitch (HG_SK, m_sCoderState.SK==1 ? false : true);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnBK_Btn() 
{
    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // switch ARI BK
    int result = HG_SetSwitch (HG_BK, m_sCoderState.BK==1 ? false : true);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnDK_Btn() 
{
    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // switch ARI DK
    int result = HG_SetSwitch (HG_DK, m_sCoderState.DK==1 ? false : true);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnSK_Chk()  // ARI SK
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_SK, m_sCoderState.SK==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnBK_Chk()  // ARI BK 
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_BK, m_sCoderState.BK==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnDK_Chk()  // ARI DK
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_DK, m_sCoderState.DK==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnPilotChk()  // pilot tone
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_PILOT, m_sCoderState.Pilot==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnStereoChk()   // stereo multiplexer
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_STEREO, m_sCoderState.Stereo==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnST1L_Chk()  // left stereo tone, internal modulator
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_ST1L, m_sCoderState.ST1L==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnST1R_Chk()  // right stereo tone, internal modulator
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_ST1R, m_sCoderState.ST1R==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnST2L_Chk()  // left stereo tone, external modulator
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_ST2L, m_sCoderState.ST2L==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnST2R_Chk()  // right stereo tone, external modulator
{
    SetCursor(m_waitcur);
    int result = HG_SetSwitch (HG_ST2R, m_sCoderState.ST2R==1 ? false : true);
    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnProgListBtn()  // dialog box with program slot list
{
    sHG_ProgSlot* List;

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    // get pointer to list of program slots
    int result = HG_GetProgList (&List);
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    if (result==HG_ERR_NO) 
    {
        CProgSlotListDlg ProgSlotListDlg;
        ProgSlotListDlg.SetData (List, m_sCoderState.Slot);
        ProgSlotListDlg.DoModal(); 
    }
    else
        MessageBox (HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnResetBtn()
{
    CString str;
    str.LoadString(IDS_RESET_INFO);

    if (MessageBox(str, m_strTitle, MB_ICONWARNING | MB_OKCANCEL)!=IDOK)
        return;  // cancel

    SetCursor(m_waitcur);

    ////////////////// HG 81300-B/PC ////////////////////////////////////
    int result = HG_Reset();
    ////////////////// HG 81300-B/PC ////////////////////////////////////

    SetCursor(m_normcur);
    if (result==HG_ERR_NO)
        Refresh();
    else
        MessageBox(HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnFirmaBmp()  // about...
{
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
}

void CRDS_HG813B_DLL_Demo_Dlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    //if (nSBCode == SB_THUMBPOSITION || nSBCode == SB_THUMBTRACK)
    {
        CString str;
        if ((CSliderCtrl*)pScrollBar == &m_FreqASlider)  // update frequency edit control
        {
            str.Format("%.1f", /*nPos*/m_FreqASlider.GetPos()/10.);
            SetDlgItemText (IDC_FREQA_EDIT, str);
        }
        else
        if ((CSliderCtrl*)pScrollBar == &m_FreqBSlider)
        {
            str.Format("%.1f", /*nPos*/m_FreqBSlider.GetPos()/10.);
            SetDlgItemText (IDC_FREQB_EDIT, str);
        }
    }

    CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CRDS_HG813B_DLL_Demo_Dlg::OnCOMnBtn()
{
    CCOMSelectDlg COMSelectDlg;
    COMSelectDlg.m_COMx = 0;  // suggest COM1
    if (COMSelectDlg.DoModal()==IDOK)  // dialog select COM n
    {
        RedrawWindow();

        ////////////////// HG 81300-B/PC ////////////////////////////////////
        // close and open new COM port
        int result = HG_Close();  // (doesn't matter if not opened yet)
        if (result==HG_ERR_NO ||
            result==HG_ERR_NOT_INIT)
        {
            KillTimer(1);  // (if any started)
            result = HG_Open (COMSelectDlg.m_COMx >= 0 ?
                              COMSelectDlg.m_COMx +1 : 1);  // default COM1
        }
        ////////////////// HG 81300-B/PC ////////////////////////////////////

        if (result==HG_ERR_NO ||
            result==HG_ERR_READING)
        {
            SetTimer (1, 1000, NULL);  // timer ticks every 1 sec.
            Refresh();
        }
        else
            MessageBox (HG_ErrorMsg(result), m_strTitle, MB_ICONEXCLAMATION);
    }
}

void CRDS_HG813B_DLL_Demo_Dlg::OnWM_User(WPARAM wParam, LPARAM lParam)
{
    if (wParam == 12345)  // message sent in OnInitDialog()
        OnCOMnBtn();      // 1st action: select and open serial interface
};

BOOL CRDS_HG813B_DLL_Demo_Dlg::OnToolTipNotify (UINT id, NMHDR* pNMHDR, LRESULT* pResult)
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT         nID  = pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        nID = ::GetDlgCtrlID((HWND)nID);
        if (nID)
        {
            pTTT->lpszText = MAKEINTRESOURCE (nID);
            pTTT->hinst = AfxGetResourceHandle();
            return TRUE;
        }
    }
    return FALSE;
}

//EOF
