/////////////////////////////////////////////////////////////////////////////
//
//                        Demo Application for
//        DLL API for RDS Signal Generator "HG 81300-B/PC" v1.0
//       -------------------------------------------------------
//
//    remote control of RDS-coder "HG 81300-B/PC" via serial COM port
//    for Microsoft Windows 32 bit, developed with Microsoft Visual C++ 6.0
//
//    (C) 2001 by Gtting KG, radio sets   Author: O. Herbst, Feb. 2001
//
//    address: Gtting KG, Celler Strae 5, 31275 Lehrte/Rddensen, Germany
//    http:    www.goetting.de
//    email:   RDS-Support@Goetting.de
//
/////////////////////////////////////////////////////////////////////////////


// RDS HG813B DLL Demo Dlg.h : header file
//

#if !defined(AFX_RDSHG813BDLLDEMODLG_H)
#define      AFX_RDSHG813BDLLDEMODLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RDS HG81300B.h"  // DLL API

/////////////////////////////////////////////////////////////////////////////
// declaration of dialog CRDS_HG813B_DLL_Demo_Dlg

class CRDS_HG813B_DLL_Demo_Dlg : public CDialog
{
public:
	CRDS_HG813B_DLL_Demo_Dlg(CWnd* pParent = NULL);  // default constructor

// dialog field data
	//{{AFX_DATA(CRDS_HG813B_DLL_Demo_Dlg)
	enum { IDD = IDD_RDS_HG813B_DLL_DEMO };
	int	    m_SlotNo;
	int		m_Times;
	int		m_NextNo;
	double	m_FreqA;
	double 	m_FreqB;
	CSliderCtrl m_FreqASlider;
	int		m_FreqASliderValue;
	CSliderCtrl	m_FreqBSlider;
	int		m_FreqBSliderValue;
	CButton	m_SK;
	CButton	m_BK;
	CButton	m_DK;
	CButton	m_Pilot;
	CButton	m_Stereo;
	CButton	m_ST1L;
	CButton	m_ST1R;
	CButton	m_ST2L;
	CButton	m_ST2R;
	CButton	m_TimerCheck;
	CString	m_Memory;
	CProgressCtrl	m_Progress1;
	CProgressCtrl	m_Progress2;
	//}}AFX_DATA

protected:
	HICON     m_hIcon;               // program icon
    CString   m_strTitle;            // title of message boxes
    HCURSOR   m_waitcur, m_normcur;  // mouse cursors

    sHG_state m_sCoderState;         //----- the state of the RDS coder

    CString   m_strFilename;         // file name of RDS sequence to load
    char      m_acSlotName [HG_NAME_LEN_MAX+1];  // name for program slot

	//{{AFX_VIRTUAL(CRDS_HG813B_DLL_Demo_Dlg)
	protected:
	virtual void DoDataExchange (CDataExchange* pDX);  // DDX/DDV support
	//}}AFX_VIRTUAL

// implementation
    void Refresh (bool cur = true);  // rereads RDS-coder state and displays its elements
    void Test (int);                 // RDS-programs for tests
	void LoadFile ();                // reads and stores a RDS sequence

public:
    void SlotSel (int slot);  // switches to program slot
    void SlotDel (int slot);  // deletes data in program slot

protected:
	//{{AFX_MSG(CRDS_HG813B_DLL_Demo_Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnResetBtn();
	afx_msg void OnTest1Btn();
	afx_msg void OnTest2Btn();
	afx_msg void OnFreqA_Btn();
	afx_msg void OnFreqB_Btn();
	afx_msg void OnFreqA_Rad();
	afx_msg void OnFreqB_Rad();
	afx_msg void OnSK_Btn();
	afx_msg void OnBK_Btn();
	afx_msg void OnDK_Btn();
	afx_msg void OnSK_Chk();
	afx_msg void OnBK_Chk();
	afx_msg void OnDK_Chk();
	afx_msg void OnPilotChk();
	afx_msg void OnStereoChk();
	afx_msg void OnST1L_Chk();
	afx_msg void OnST1R_Chk();
	afx_msg void OnST2L_Chk();
	afx_msg void OnST2R_Chk();
	afx_msg void OnProgListBtn();
	afx_msg void OnFirmaBmp();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnTimerChk();
	afx_msg void OnCOMnBtn();
	afx_msg void OnLoadBtn();
	//}}AFX_MSG

    BOOL OnToolTipNotify (UINT id, NMHDR * pNMHDR, LRESULT * pResult);
    void OnWM_User (WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_RDSHG813BDLLDEMODLG_H)
